Bug 1725790 - python-gast fails to build with Python 3.8
Summary: python-gast fails to build with Python 3.8
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: python-gast
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
high
Target Milestone: ---
Assignee: Miro Hrončok
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: PYTHON38 F32FTBFS F32FailsToInstall
TreeView+ depends on / blocked
 
Reported: 2019-07-01 13:05 UTC by Miro Hrončok
Modified: 2019-10-12 23:54 UTC (History)
3 users (show)

Fixed In Version: python-gast-0.3.2-1.fc32
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-10-12 23:54:54 UTC


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Github serge-sans-paille gast issues 33 None None None 2019-07-30 14:57:25 UTC

Description Miro Hrončok 2019-07-01 13:05:40 UTC
python-gast fails to build with Python 3.8.0b1.

======================================================================
ERROR: testCompile (tests.test_self.SelfTestCase)
----------------------------------------------------------------------
Traceback (most recent call last):
  File "/builddir/build/BUILD/gast-0.2.2/tests/test_self.py", line 27, in testCompile
    compile(gast.gast_to_ast(gnode), src_py, 'exec')
TypeError: arguments field "posonlyargs" must be a list, not a NoneType

======================================================================
ERROR: test_unparse (tests.test_self.SelfTestCase)
----------------------------------------------------------------------
Traceback (most recent call last):
  File "/builddir/build/BUILD/gast-0.2.2/tests/test_self.py", line 34, in test_unparse
    astunparse.unparse(gast.gast_to_ast(gnode))
  File "/usr/lib/python3.8/site-packages/astunparse/__init__.py", line 13, in unparse
    Unparser(tree, file=v)
  File "/usr/lib/python3.8/site-packages/astunparse/unparser.py", line 38, in __init__
    self.dispatch(tree)
  File "/usr/lib/python3.8/site-packages/astunparse/unparser.py", line 66, in dispatch
    meth(tree)
  File "/usr/lib/python3.8/site-packages/astunparse/unparser.py", line 78, in _Module
    self.dispatch(stmt)
  File "/usr/lib/python3.8/site-packages/astunparse/unparser.py", line 66, in dispatch
    meth(tree)
  File "/usr/lib/python3.8/site-packages/astunparse/unparser.py", line 328, in _ClassDef
    self.dispatch(t.body)
  File "/usr/lib/python3.8/site-packages/astunparse/unparser.py", line 63, in dispatch
    self.dispatch(t)
  File "/usr/lib/python3.8/site-packages/astunparse/unparser.py", line 66, in dispatch
    meth(tree)
  File "/usr/lib/python3.8/site-packages/astunparse/unparser.py", line 347, in _FunctionDef
    self._generic_FunctionDef(t)
  File "/usr/lib/python3.8/site-packages/astunparse/unparser.py", line 337, in _generic_FunctionDef
    self.dispatch(t.args)
  File "/usr/lib/python3.8/site-packages/astunparse/unparser.py", line 66, in dispatch
    meth(tree)
  File "/usr/lib/python3.8/site-packages/astunparse/unparser.py", line 763, in _arguments
    defaults = [None] * (len(t.args) - len(t.defaults)) + t.defaults
AttributeError: 'arguments' object has no attribute 'defaults'

======================================================================
ERROR: test_ArgAnnotation (tests.test_compat.CompatTestCase)
----------------------------------------------------------------------
Traceback (most recent call last):
  File "/builddir/build/BUILD/gast-0.2.2/tests/test_compat.py", line 48, in test_ArgAnnotation
    compile(gast.gast_to_ast(tree), '<test>', 'exec')
TypeError: arguments field "posonlyargs" must be a list, not a NoneType

======================================================================
ERROR: test_Call (tests.test_compat.CompatTestCase)
----------------------------------------------------------------------
Traceback (most recent call last):
  File "/builddir/build/BUILD/gast-0.2.2/tests/test_compat.py", line 63, in test_Call
    compile(gast.gast_to_ast(tree), '<test>', 'exec')
ValueError: field value is required for keyword

======================================================================
ERROR: test_FormattedValue (tests.test_compat.CompatTestCase)
----------------------------------------------------------------------
Traceback (most recent call last):
  File "/builddir/build/BUILD/gast-0.2.2/tests/test_compat.py", line 70, in test_FormattedValue
    compile(gast.gast_to_ast(tree), '<test>', 'exec')
ValueError: field value is required for Assign

======================================================================
ERROR: test_JoinedStr (tests.test_compat.CompatTestCase)
----------------------------------------------------------------------
Traceback (most recent call last):
  File "/builddir/build/BUILD/gast-0.2.2/tests/test_compat.py", line 75, in test_JoinedStr
    compile(gast.gast_to_ast(tree), '<test>', 'exec')
ValueError: field value is required for Assign

======================================================================
ERROR: test_KeywordOnlyArgument (tests.test_compat.CompatTestCase)
----------------------------------------------------------------------
Traceback (most recent call last):
  File "/builddir/build/BUILD/gast-0.2.2/tests/test_compat.py", line 53, in test_KeywordOnlyArgument
    compile(gast.gast_to_ast(tree), '<test>', 'exec')
TypeError: arguments field "posonlyargs" must be a list, not a NoneType

======================================================================
ERROR: test_TryExceptNamed (tests.test_compat.CompatTestCase)
----------------------------------------------------------------------
Traceback (most recent call last):
  File "/builddir/build/BUILD/gast-0.2.2/tests/test_compat.py", line 58, in test_TryExceptNamed
    compile(gast.gast_to_ast(tree), '<test>', 'exec')
TypeError: required field "type_ignores" missing from Module

======================================================================
FAIL: test_get_docstring (tests.test_api.APITestCase)
----------------------------------------------------------------------
Traceback (most recent call last):
  File "/builddir/build/BUILD/gast-0.2.2/tests/test_api.py", line 69, in test_get_docstring
    self.assertEqual(docs, "foo")
AssertionError: None != 'foo'

======================================================================
FAIL: test_walk (tests.test_api.APITestCase)
----------------------------------------------------------------------
Traceback (most recent call last):
  File "/builddir/build/BUILD/gast-0.2.2/tests/test_api.py", line 45, in test_walk
    self.assertEqual(dump, norm)
AssertionError: "Expr[30 chars]='x', ctx=Load(), annotation=None), op=Add(), right=None))" != "Expr[30 chars]='x', ctx=Load(), annotation=None), op=Add(), right=Num(n=1)))"
- Expression(body=BinOp(left=Name(id='x', ctx=Load(), annotation=None), op=Add(), right=None))
?                                                                                        ^ ^
+ Expression(body=BinOp(left=Name(id='x', ctx=Load(), annotation=None), op=Add(), right=Num(n=1)))
?                                                                                        ^^^ ^^^


----------------------------------------------------------------------
Ran 22 tests in 0.097s

For the build logs, see:
https://copr-be.cloud.fedoraproject.org/results/@python/python3.8/fedora-rawhide-x86_64/00952908-python-gast/

For all our attempts to build python-gast with Python 3.8, see:
https://copr.fedorainfracloud.org/coprs/g/python/python3.8/package/python-gast/

Testing and mass rebuild of packages is happening in copr. You can follow these instructions to test locally in mock if your package builds with Python 3.8:
https://copr.fedorainfracloud.org/coprs/g/python/python3.8/

Let us know here if you have any questions.

Comment 1 Ben Cotton 2019-08-13 17:11:28 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 31 development cycle.
Changing version to '31'.

Comment 2 Ben Cotton 2019-08-13 18:52:13 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 31 development cycle.
Changing version to 31.

Comment 3 Miro Hrončok 2019-08-14 22:24:04 UTC
The coordinated rebuild of Python 3.8 has started in the `f32-python` side tag.

If you figure out how to rebuild this package, please don't rebuild it in regular rawhide, but use the side tag instead:

    on branch master:
    $ fedpkg build --target=f32-python

To wait for a build to show up in the side tag, do:

    $ koji wait-repo f32-python --build=<nvr>

Where <nvr> is name-version-release of the source package, e.g. python-foo-1.1-2.fc32.

An updated mock config is posted at:
http://copr.fedorainfracloud.org/coprs/g/python/python3.8/

Note that it will take a while before the essential packages are rebuilt, so don't expect all your dependencies to be available right away.

Thanks. Let us know if you need up to date info, or if you have any questions.



PS this message is mass posted to all the bugs that block the PYTHON38 bug. If this is also a Fedora 31 FTBFS bug and you manage to fix it, you can do a f31 build as usual:

    on branch f31:
    $ fedpkg build

Comment 4 Miro Hrončok 2019-08-21 16:34:20 UTC
The f32-python side tag has been merged. In order to rebuild the package, do it in regular rawhide, but please wait until python3-3.8 is tagged:

  $ koji wait-repo f32-build --build python3-3.8.0~b3-3.fc32


If your built already started in f32-python, after it is finished, please tag it to rawhide with:

  $ koji tag-build f32-pending <nvr>

For example:

  $ koji tag-build f32-pending libreoffice-6.3.0.4-3.fc32

Thanks!

(This comment is mass posted to all bugzillas blocking the PYTHON38 tracking bug.)

Comment 5 Miro Hrončok 2019-08-21 17:28:56 UTC
(Python 3.8 has landed in the rawhide buildroot.)

Comment 6 Miro Hrončok 2019-09-16 08:44:17 UTC
Update: An upstream fix is being worked on. I'll update gast, beniget and pythran once it is ready, hopefully soon.

https://github.com/serge-sans-paille/gast/issues/33


Note You need to log in before you can comment on or make changes to this bug.